--[[Copyright (c) 2012-2021 Baby-Bus.com
Author: cxy
Date: 2021-1-13

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]
----------------------
-- 类
----------------------
local M    = classSpriteTouch("Outline")
M.TAG    = "Outline"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..
----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)

    self._main  = params.main
    -- 数字
	self._num   = params.num
    -- 出场后的倍数
    self._scale = params.scale
    -- 初始坐标位置
	self._pos   = params.pos
end

----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()
end

-- 图片渲染
function M:loadDisplay()
    self:display("num/puzzle/number/outline"..self._num..".png")
end

-- 虚线轮廓进场效果
function M:enterEffect(callback)
    -- 播放音效[sfx14707001]虚线框冒出/虚线框冒出的时候播放
    soundEffect:playEffectsfx14707001()
    self:line({
        { "easing", "backOut", { "scaleTo", 0.3, self._scale } },
        {"fn", function ()
            if callback then
                callback()
            end
        end}
    })
end

-- 轮廓消失效果
function M:quitEffect(callback)
    self:line({
		{"fadeTo", 0.3, 0},
        {"fn", function ()
            if callback then
                callback()
            end
        end},
        {"remove"}
    })
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end


----------------------
-- 点击
----------------------
function M:onTouchBegan(x, y, touches)
    return true
end

function M:onTouchMoved(x, y, touches)

end

function M:onTouchEnded(x, y, touches)

end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)

end


return M