--[[

Copyright (c) 2012-2019 Baby-Bus.com

http://www.baby-bus.com/LizardMan/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[--

场景层类，定义层相关操作方法及逻辑实现。

-   定义场景层功能方法。

]]

----------------------
-- 类
----------------------
local M = classLayerTouch("Background")


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..

-- [操作变量]
-- ..








----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义视图实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	M.super.ctor(self)
end








----------------------
-- 视图渲染
----------------------
--[[--

视图渲染，处理视图结点加载、事件绑定等相关操作

]]
function M:onRender()
	self._bgs 	= {}
	for i=1,4 do
		local bg = D.img("num/write/bg.png"):scale(1.25):a(cc.p(0.5, 0)):to(self):p(V.w_2 + (i - 2) * 1280, 0)
		table.insert(self._bgs, bg)
	end

    -- 循环调整位置
    self:scheduleUpdateWithPriorityLua(function (dt)
        for i, v in ipairs(self._bgs) do
            local px = v:px()
            if px > 1280 * 2 + V.w_2 then
                v:px(px - 1280 * #self._bgs)
            elseif px < V.w_2 - 2 * 1280 then
                v:px(px + 1280 * #self._bgs)
            end
        end
    end, 1)
end

-- 背景移动
function M:bgMoveBy(time, offsetPoint)
	for i,v in ipairs(self._bgs) do
		v:line({
			{"moveBy", time, offsetPoint},
		})
	end
end





return M