--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-1-13

]]

--[[!--

场景层类，定义层相关操作方法及逻辑实现。

-   定义场景层功能方法。

]]

----------------------
-- 类 -- 按钮层
----------------------
local M = class('Button', BaseButton)

----------------------
-- 公共参数
----------------------
-- [常量]
-- ..

-- [操作变量]
-- ..








----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义视图实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
end








----------------------
-- 结点渲染
----------------------
--[[--

视图渲染，处理视图结点加载、事件绑定等相关操作

]]
function M:onRender()
    M.super.onRender(self, params)
    -- 菜单栏
    self:loadMenuButton()
end

function M:onEnterTransitionFinish()
end


-- 跳过按钮 各场景重写此方法
function M:btnSkipEvent()
	-- self:getParent():enterNextScene()
    CUtil:enterSceneWithLoadMould("numline")
end

-- 菜单键
function M:loadMenuButton()
	local menuBtn = require("app.numwrite.node.Menu").new({
		num = self:getParent()._number
	}):to(self, 2000):p(70 + X_OFFSET, 70)
	self._menuBtn = menuBtn

    self:getParent()._menuBtn = menuBtn
end



----------------------
-- 结点析构
----------------------
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end



return M