--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-8

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 规范书写箭头
----------------------
local M     = classSpriteTouch("Arrow")
M.TAG       = "Arrow"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)
	-- 层
	self._layer 	= params.layer
	-- 所属数字节点
	self._numNode 	= params.numNode
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
	-- 图片渲染
	self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
	self:display("num/write/arrow.png")
end

-- 播放拖动音效
function M:playPullEffect()
	-- if self._pullEffect then return end
	-- self._pullEffect = soundEffect:playEffectsfx14711018()

end

-- 停止拖动音效
function M:stopPullEffect()
	-- if self._pullEffect then
	-- 	sound.stopSound(self._pullEffect)
	-- 	self._pullEffect = nil
	-- end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end


----------------------
-- 点击
----------------------

function M:onTouchBegan(x, y, touches)
	if self._touchLock then return end
	self:getScene()._menuBtn:barChange(false)
	self._touchLock = true
	self._numNode:stopGuide()
	self:playPullEffect()
	self:scale(1.2)
	return true
end

function M:onTouchMoved(x, y, touches)
	return self._numNode:arrowTouchMove(x, y)
end

function M:onTouchEnded(x, y, touches)
	self._numNode:arrowBack()
end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M