--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-2-24

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 	-- 数字2骨骼
----------------------
local M    = class("NumBone2", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone2"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)

	-- self:jumpAwayAct()
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz1_huxi_1"           -- 呼吸
    self._breathAni2    = "sz1_huxi_2"           -- 呼吸眨眼
    self._walkAni       = "sz1_tiao_2"           -- 走路(跳)
    self._standbyAni    = "sz1_zhayan"           -- 待机-眨眼动画
    self._clickAni      = "sz1_jinqi"           -- 点击反馈-惊奇动画
end


-- 写字完成
function M:writeFinish()
	self:eyesGlowAct()
end

-- 吃面包
function M:eatBread()
	self:eatAct1()
end


-- 甩飞帽子动画-0
function M:flyHatAct()
	self:playAni("sz1_shuaitou")
end

-- 眼睛发光-0
function M:eyesGlowAct()
	self:z(300)
	self:playAni("sz1_jinya")
end

-- 蹦跳-1
function M:jumpAct()
	self:playAni("sz1_tiao_1")
end

-- 跑金币-1
function M:holdCoinAct()
	self:playAni("sz1_paojb")
end

-- 准备吃面包-0
function M:eatAct1()
	self:playAni("sz1_chi_1")
end
-- 吃中-1
function M:eatAct2()
	self:playAni("sz1_chi_2")
end
-- 结束吃-0
function M:eatAct3()
	self:playAni("sz1_chi_3")
end

-- 吃完面包开心蹦跳离开-1
function M:ateAwayhappyAct()
	self:playAni("sz1_tiao_3")
end




function M:handlerOnDerived( __evtType, __moveId )
	if __evtType == 1 then
		if __moveId == "sz1_chi_1" then
			self:eatAct2()
			self:line({
				{"delay", 1.5},
				{"fn", function()
					self:eatAct3() 
				end},
			})
		elseif __moveId == "sz1_chi_3" then
			self._layer._door:closeCurtain()
			self:ateAwayhappyAct()
			self:z(9999):line({
				{"moveBy", 2, cc.p(1000, 0)},
				{"remove"},
			})
			local layer = self._layer
			layer:autoRemove(self)
			layer:line({
				{"delay", 2},
				{"fn", function()
					layer:ending() 
				end},
			})

		elseif __moveId == "sz1_shuaitou" then
			self:breathAct()
		elseif __moveId == "sz1_jinya" then

			self:jumpAct()
			self:line({
				{"moveTo", 0.88, cc.p(V.w_2, self:py())},
				{"fn", function()
					self:holdCoinAct()
				end},
				{"delay", 2.8},
				{"fn", function()
					self:walkAct()
					self._layer:sceneLeftMove()
				end},
			})
		end
	end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M