--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-10

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类    -- 数字10骨骼
----------------------
local M    = class("NumBone10", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone10"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz10_huxi_1"          -- 呼吸
    self._breathAni2    = "sz10_huxi_2"          -- 呼吸眨眼
    self._walkAni       = "sz10_tiao"          -- 走路(跳)
    self._standbyAni    = "sz10_zhayan"          -- 待机-眨眼动画
    self._clickAni      = "sz10_dazh_1"           -- 点击反馈-开心动画
end

-- 书写完成
function M:writeFinish()
    self:hatAct()
end

-- 开心的出去
function M:happyOut()
    self._layer._numPath:loadFireworksParticle()
    self:cheerAct()

    local particle = P.new("particle/lihua.plist"):to(self):p(140, 160)
    particle:setAutoRemoveOnFinish(true)
    soundEffect:playEffectsfx14711099()

    self:z(1000):line({
        {"delay", 1.89},
        {"fn", function()
            self:walkAct()

            local layer = self._layer
            layer:autoRemove(self)
            layer:line({
                {"delay", 3},
                {"fn", function()
                    layer:ending() 
                end},
            })
        end},
        {"moveBy", 3, cc.p(1300, 0)},
        {"remove"},
    })
end

function M:moveToDoorCallback()
    self:z(1000)
end


-- 准备伸手-点击动画 - 0
function M:clickAct1()
    self:playAni("sz10_dazh_1")
end
-- 打招呼-点击动画 - 1
function M:clickAct2()
    self:playAni("sz10_dazh_2", nil, {loop = 0})
end
-- 结束-点击动画 - 0
function M:clickAct3()
    self:playAni("sz10_dazh_3")
end

-- 戴生日帽-第二次书写后动画 - 0
function M:hatAct()
    self:playAni("sz10_daimz")
end

-- 鼓掌动画-第二次书写后动画 - 1
function M:clapAct()
    self:playAni("sz10_guzhang")
end

-- 吹蜡烛-第二次书写后动画 - 0
function M:blowAct()
    self:playAni("sz10_chui")
end

-- 鼓掌撒彩带-反馈动画 - 1
function M:cheerAct()
    self:playAni("sz10_sacd")
end



function M:handlerOnDerived( __evtType, __moveId )
    if __evtType == 1 then
        if __moveId == "sz10_daimz" then
            self:clapAct()
            self:line({
                {"delay", 0.42 * 4},
                {"fn", function()
                    self:blowAct()
                    self._layer._numPath:candlePutOut()
                end},
            })
        elseif __moveId == "sz10_chui" then
            -- self:breathAct1()
            self:walkAct()
            self._layer:sceneLeftMove()

        -- 点击反馈
        elseif __moveId == self._clickAni then
            self:clickAct2()
            return true
        elseif __moveId == "sz10_dazh_2" then
            self:clickAct3()
        elseif __moveId == "sz10_dazh_3" then
            self:breathAct()
        end
    end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    
end


return M