--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-2-24

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 	-- 数字2骨骼
----------------------
local M    = class("NumBone2", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone2"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz2_huxi_1"          -- 呼吸
    self._breathAni2    = "sz2_huxi_2"          -- 呼吸眨眼
    self._walkAni       = "sz2_tiao"            -- 走路(跳)
    self._standbyAni    = "sz2_shentou"         -- 待机-伸头瞪大眼睛动画
    self._clickAni      = "sz2_ye"           	-- 点击反馈-开心跳起来比耶
end


-- 写字完成 跑马灯起来跳舞
function M:writeFinish()
	self:playGuitarAct()
	self:line({
		{"delay", 3},
		{"fn", function()
			self:walkAct()
			self._layer:sceneLeftMove()
		end},
	})
end

-- 移动上马
function M:moveToHorse(horse)
	soundEffect:playEffectsfx14711030()
	local px = horse:worldx()
	self:walkAct()
	self:z(1000):line({
		A.union({
			{"moveTo", 1.14, cc.p(px, self:y() + 16 + Y_OFFSET / 2)},
			{"scaleTo", 1.14, 0.75},
		}),
		{"fn", function()
			self:scale(0.75)
			horse:hide()
			self:horseAct1()
		end},
		{"delay", 1.84},
		{"fn", function()
			self:horseAct2()
		end},
		{"delay", 1.62},
		{"fn", function()
			self:horseAct3()
		end},
	})
end


-- 眼睛闪烁动画 - 0 第一次书写后动画
function M:eyeTwinkleAct()
	self:playAni("sz2_shansuo")
end

-- 弹吉他 - 0 第二次书写后动画
function M:playGuitarAct()
	self:playAni("sz2_tjita")
end

-- 做木马摇晃 - 1
function M:horseAct1()
	self:playAni("sz2_muma_1")
end

-- 做木马摇晃（快 - 1
function M:horseAct2()
	self:playAni("sz2_muma_2")
end

-- 做木马摇晃弹出屏幕 - 0
function M:horseAct3()
	self:playAni("sz2_muma_3")
end


function M:handlerOnDerived( __evtType, __moveId )
	if __evtType == 1 then
		if __moveId == "sz2_muma_3" then
			self._layer:ending()
		elseif __moveId == "sz2_shansuo" then
			self:breathAct()
		end
	end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M