--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-10

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 	-- 数字3骨骼
----------------------
local M    = class("NumBone3", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone3"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz3_huxi_1"           -- 呼吸
    self._breathAni2    = "sz3_huxi_2"           -- 呼吸眨眼
    self._walkAni       = "sz3_tiao"           -- 走路(跳)
    self._standbyAni    = "sz3_zhayan"           -- 待机-眨眼动画
    self._clickAni      = "sz3_gaoxin"           -- 点击反馈-高兴跳起来动画
end

-- 写字完成 臭美
function M:writeFinish()
	soundEffect:playEffectsfx14711038()
	self:beautyAct()
end

function M:catchButterfly()
	soundEffect:playEffectsfx14711040()
	self:surpriseAct()
end


-- 臭美动画 -0
function M:beautyAct()
	self:playAni("sz3_coumei")
end

-- 惊喜动画 -0
function M:surpriseAct()
	self:playAni("sz3_jinxi")
end

-- 追蝴蝶动画 -1
function M:butterflyAct()
	self:playAni("sz3_zhuihd")
end



function M:handlerOnDerived( __evtType, __moveId )
	if __evtType == 1 then
		if __moveId == "sz3_coumei" then
			self:walkAct()
			self._layer:sceneLeftMove()
		elseif __moveId == "sz3_jinxi" then
			self:butterflyAct()
			self:z(1000):line({
				{"moveBy", 2, cc.p(1300, 0)},
				{"remove"},
			})

			local layer = self._layer
			layer:autoRemove(self)
			layer:line({
				{"delay", 2},
				{"fn", function()
					layer:ending() 
				end},
			})
		end
	end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M