--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-10

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 	-- 数字7骨骼
----------------------
local M    = class("NumBone7", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone7"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz7_huxi_1"          -- 呼吸
    self._breathAni2    = "sz7_huxi_2"          -- 呼吸眨眼
    self._walkAni       = "sz7_likai"            -- 走路(跳)
    self._standbyAni    = "sz7_zhayan"          -- 待机-眨眼动画
    self._clickAni      = "sz7_ronghua"            -- 点击反馈-融化动画
end

-- 跳出
function M:jumpOut()
	soundEffect:playEffectsfx14711072()
	self:walkAct()
	self:z(1000):line({
		{"moveBy", 2, cc.p(1300, 0)},
		{"remove"},
	})

	local layer = self._layer
	layer:autoRemove(self)
	layer:line({
		{"delay", 2},
		{"fn", function()
			layer:ending() 
		end},
	})
end



-- 写字完成高兴
function M:writeFinish()
	soundEffect:playEffectsfx14711070()
    self:walkAct()
    self._layer:sceneLeftMove()
end


-- 惊讶动画-换场动画 - 0
function M:surpriseAct1()
	self:playAni("sz7_jinya")
end

-- 开心动画-反馈动画 - 1
function M:happyAct1()
	self:playAni("sz7_kaixin")
end


function M:handlerOnDerived( __evtType, __moveId )
	
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M