--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-10

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 	-- 数字8骨骼
----------------------
local M    = class("NumBone8", require("app.numwrite.numbone.NumBoneBase"))
M.TAG    = "NumBone8"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
end


-- 初始化通用动作名
function M:initCommonAnimationName()
    self._breathAni1    = "sz8_huxi_1"          -- 呼吸
    self._breathAni2    = "sz8_huxi_2"          -- 呼吸眨眼
    self._walkAni       = "sz8_tiao_1"          -- 走路(跳)
    self._standbyAni    = "sz8_zhayan"          -- 待机-眨眼动画
    self._clickAni      = "sz8_paot"            -- 点击反馈-开心动画
end


-- 写字完成
function M:writeFinish()
	soundEffect:playEffectsfx14711085()
	self:walkAct()
	self._layer:sceneLeftMove()
end


-- 被冻僵
function M:beFrozen()
	local particle = P.new("particle/feixue.plist"):to(self):p(self:cw()/2, self:ch()/2)
	particle:setAutoRemoveOnFinish(true)
	self._particle = particle

	soundEffect:playEffectsfx14711086()
	self:coldAct1()
end


-- 冷动画-反馈动画 - 0
function M:coldAct1()
	self:playAni("sz8_leng")
end

-- 跳出屏幕动画-反馈动画 - 1
function M:jumpAwayAct1()
	self:playAni("sz8_tiao_2")
end


function M:handlerOnDerived( __evtType, __moveId )
	if __evtType == 1 then
		if __moveId == "sz8_leng" then
			self._particle:stopSystem()
			self:jumpAwayAct1()
			self:z(1000):line({
				{"moveBy", 3, cc.p(1300, 0)},
				{"remove"},
			})

			local layer = self._layer
			layer:autoRemove(self)
			layer:line({
				{"delay", 3},
				{"fn", function()
					layer:ending() 
				end},
			})
		end
	end
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end




----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M