--[[

Copyright (c) 2012-2021 Baby-Bus.com
Author: cxy
Date: 2021-3-11

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字3的花花
----------------------
-- local M     = classSprite("N3Flower")
local M     = classArmatureTouch("N3Flower")
M.TAG       = "N3Flower"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..


-- 三个花花
local files     = {"bone/huahua", "bone/hua2", "bone/hua3"}

local armatures = {"huahua", "hua2", "hua3"}
-- 花开出动画名
local ani1      = {"huahua", "hua_2", "hua3"}
-- 花缩回动画名
local ani2      = {"huahua_hui", "hu2_hui", "hua3-hui"}

local boneName  = {
    {"hua_1dixia", "hua-1a1", "hua-1a2", "hua_1a3", "hua-1a4"},
    {"hua2_a3", "hua2_a4", "hua2_a5", "hua2_a6", "hua2_a7"},
    {"hua3_3", "hua3_a4", "hua3_a5", "hua3_a6", "hua3_a17"},
}

----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    -- 轨迹数字节点
    self._numNode   = params.numNode
    -- 在数字轨迹上坐标的索引
    self._posIndex  = params.posIndex

    self._id        = params.id or 1

    self._file            = files[self._id]
    -- 字段[骨架名称]
    self._armatureName    = armatures[self._id]
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
    -- self:setTexture("num/write/num3/flower"..self._id.."/f1.png"):a(cc.p(0.5, 0.2))
end

-- 盛开
function M:bloom()
    if self._bloomed then return end
    self._bloomed = true

    self:show():play(ani1[self._id])
end

-- 缩回
function M:retract()
    if not self._bloomed then return end
    self._bloomed = false
    self:play(ani2[self._id])
end

-- 花瓣掉落
function M:petalDrop()
    if self._droped then return end
    self._droped = true
    self._numNode:playFlowerEffect()
    for i,v in ipairs(boneName[self._id]) do
        self:getBone(v):hide()
    end
end

-- 花瓣恢复
function M:petalRecovery()
    if not self._droped then return end
    self._droped = false
    for i,v in ipairs(boneName[self._id]) do
        self:getBone(v):show()
    end
end


----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    
end


return M