--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-2-24

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类    数字3的洒水壶
----------------------
local M     = classSpriteTouch("N3Pot")
M.TAG       = "N3Pot"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    -- 层
    self._layer         = params.layer

    self._numNode       = params.numNode
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()
end

-- 图片渲染
function M:loadDisplay()
    self:display("num/write/num3/pot.png")
    local particle = P.new("particle/jiaoshui.plist"):to(self):p(10, 80):hide()
    self._particle = particle
end


function M:quit()
    self:line({
        {"scaleTo", 0.3, 0},
        {"remove"},
    })
end


function M:playAni()
    self:rotate(-30):scale(0.8)
    self._particle:rotate(30):show()
end


function M:stopAni()
    self:rotate(0):scale(1)
    self._particle:hide()
end


--------------------------
-- 触控
-------------------------- 

function M:onTouchBegan(x, y, touches)
    if self._touchLock then return end
    self._touchLock = true
    self._numNode._canPlayEffect = true
    self:playAni()
    self._numNode:stopGuide()
    self:getScene()._menuBtn:barChange(false)

    return SIGN_TOUCH_BEGAN_SWALLOWS
end

function M:onTouchMoved(x, y, touches)
    return self._numNode:waterFlowers(x, y)
end

function M:onTouchEnded(x, y, touches)
    self._numNode:potGoBack()
end









----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end


return M