--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-1-21

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字2显示的灯管
----------------------
local M     = classSprite("N2Tube")
M.TAG       = "N2Tube"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    -- 显示的类型-1大弧 -2小弧
    self._type          = params.type_ or 1

    self._isHead        = params.isHead or false

    self._numNode       = params.numNode
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()

end


-- 图片渲染
function M:loadDisplay()
    self:setTexture("num/write/num6/rail/r"..self._type..".png"):scaleX(-1)
end

function M:setRailInfo(type_, pos, posIndex, rotate)
    if type_ ~= self._type and not self._isHead then
        self._type = type_
        self:loadDisplay()
    end
    self:setPosition(pos):setRotation(rotate)
    self._posIndex  = posIndex
end

--------------------------
-- 触控
-------------------------- 

function M:onTouchBegan(x, y, touches)
    if self._touchLock then return end
    self._touchLock = true
    self._numNode._canPlayEffect = true
    self._numNode:stopGuide()
    self:getScene()._menuBtn:barChange(false)
    return SIGN_TOUCH_BEGAN_SWALLOWS
end

function M:onTouchMoved(x, y, touches)
    return self._numNode:buildRail(x, y)
end

function M:onTouchEnded(x, y, touches)
    self._numNode:railBack()
end


----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
    
end


return M