--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-18

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字7用来拖的萤火虫
----------------------
local M     = classArmatureTouch("N7Glowworm")
M.TAG       = "N7Glowworm"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

	self._layer 	= params.layer

	self._numNode 	= params.numNode

    self._file            = "bone/yhc_sl"
    -- 字段[骨架名称]
    self._armatureName    = "yhc_yhc"
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
	-- 图片渲染
	self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
	self:play("yhc_fei", nil, {loop = 1})

	local particle = P.new("particle/yinghuochong.plist"):to(self, -1):p(self:cw()/2, self:ch()/2)
end

function M:onEnterTransitionFinish()
	self._iniPoint = self:point()
end

-- 飞行动画
function M:flyAni()
	if self._floatAction  then return end
	self:play("yhc", nil, {loop = 1})
	self._armPos = self._armature:point()
	self._floatAction = A.cycle({
		{"moveBy", 0.4, cc.p(9, 0)},		
		{"moveBy", 0.8, cc.p(-18, 0)},		
		{"moveBy", 0.4, cc.p(9, 0)},		
	}):at(self._armature)
end
 
function M:stopAni()
	if self._floatAction then
		self._armature:stopAction(self._floatAction):p(self._armPos)
		self._floatAction = nil
		self:play("yhc_huxi")
	end
end
M.breathAct = M.stopAni

-- 获取点亮的位置
function M:getLightPoint()
	return self:worldpoint()
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end


----------------------
-- 点击
----------------------


function M:onTouchBegan(x, y, touches)
	if self._touchLock then return end
	self._numNode._canPlayEffect = true
	self._numNode:stopGuide()
	self._numNode:loadGlowParticl()
	self:flyAni()
    self:getScene()._menuBtn:barChange(false)
	return SIGN_TOUCH_BEGAN_SWALLOWS 
end

function M:onTouchMoved(x, y, touches)
	return self._numNode:fireLight(x, y)
end

function M:onTouchEnded(x, y, touches)
	self:stopAni()
	self._numNode:lightBack()
end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M