--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-16

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字7用的铁锹
----------------------
local M     = classArmatureTouch("N7Spade")
M.TAG       = "N7Spade"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

	self._numNode 	= params.numNode

    self._file            = "bone/tiechui"
    -- 字段[骨架名称]
    self._armatureName    = "tiechui"
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
	-- 图片渲染
	self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
	-- self:display("num/write/num7/spade/s1.png")
	local particle = P.new("particle/qiaoshitou.plist"):to(self):p(-20, 50):hide()
    particle:setPositionType(cc.POSITION_TYPE_RELATIVE)
	self._particle = particle
end

function M:quit()
	self:remove()
end

function M:playAni()
	-- if self._aniAction then return end
	-- self._aniAction = A.cycle({
	-- 	{"image", "num/write/num7/spade/s", 12, 1/60},
	-- }):at(self)
	self:play("tiechui_dong")
	self._particle:show()
end


function M:stopAni()
	self:play("tiechui_dong"):stop()
	self._particle:hide()
	-- if self._aniAction then
	-- 	self:stopAction(self._aniAction)
	-- 	self._aniAction = nil
	-- 	self:loadDisplay()
	-- end
end

function M:knockAction()
	-- body
end


function M:onTouchBegan(x, y, touches)
	if self._touchLock then return end
	self._numNode:stopGuide()
	self._numNode._canPlayEffect = true
	self:playAni()
    self:getScene()._menuBtn:barChange(false)
	return SIGN_TOUCH_BEGAN_SWALLOWS 
end

function M:onTouchMoved(x, y, touches)
	return self._numNode:knockStone(x, y)
end

function M:onTouchEnded(x, y, touches)
	--  
	self._numNode:spadeBack()
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M