--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-15

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字7用的石头
----------------------
local M     = classSprite("N7Stone")
M.TAG       = "N7Stone"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)
	-- 层
	self._layer 	= params.layer
	-- 数字节点
	self._numNode 	= params.numNode
    -- 在数字轨迹上坐标的索引
    self._posIndex  = params.posIndex
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
	-- 图片渲染
	self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
	self:display("num/write/num7/stone/s1.png")
end

-- 被敲碎
function M:breakUp()
    if self._broke then return end
    self._broke = true
    -- self:scale(0):show()
    self._numNode._spade:knockAction()
    self._numNode:playBreakEffect()

    if self._restoreAction then
        self:stopAction(self._restoreAction)
        self._restoreAction = nil
    end

    self._breakAction = A.line({
        {"image", "num/write/num7/stone/s", 7, 1/24},
        {"hide"},
        {"fn", function()
            self._breakAction = nil
        end},
    }):at(self)
end

-- 石头复原
function M:restore()
    if not self._broke then return end
    self._broke = false

    if self._breakAction then
        self:stopAction(self._breakAction)
        self._breakAction = nil
    end

    self._restoreAction = A.line({
        {"show"},
        -- {"scaleTo", 0.25, 1},
        A.one({"image", "num/write/num7/stone/s", 7, 1/24}):reverse(),
        {"fn", function()
            self._restoreAction = nil
        end},
    }):at(self)
end
----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M