--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-2-24

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 类 数字8捡鱼的企鹅
----------------------
local M     = classArmatureTouch("N8Penguin")
M.TAG       = "N8Penguin"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    -- 层
    self._layer         = params.layer

    self._numNode       = params.numNode

    self._file            = self._type == 1 and "bone/chanxueche" or "bone/qie"
    -- 字段[骨架名称]
    self._armatureName    = self._type == 1 and "che" or "qie"
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()
end

-- 图片渲染
function M:loadDisplay()
    -- self:play("shuihui_dong")
end


function M:quit()
    self:line({
        {"scaleTo", 0.5, 0},
        {"remove"},
    })
end

-- 企鹅进场
function M:penguinEnter()
    self._touchLock = true
    self._iniPoint = self:point()
    self:px(self:px() + 600)

    local shakeAct = A.cycle({
        {"rotateBy", 0.05, 10},
        {"rotateBy", 0.1, -20},
        {"rotateBy", 0.05, 10},
    }):at(self)

    self:line({
        {"moveBy", 1.5, cc.p(-600, 0)},
        {"fn", function()
            self:stopAction(shakeAct):rotate(0)
            self._touchLock = false 
        end},
    })
end


function M:movementHandler( __evtType, __moveId )
    if __evtType == 1 then
        if __moveId == "qie_yu" then
            self._isInPick = false
            self:stopAction(self._pickShakeAct):rotate(0)
        end
    end
end

function M:pickAni()
    if self._isInPick then return end
    self._isInPick = true
    self:play("qie_yu")

    self._pickShakeAct = A.cycle({
        {"rotateBy", 0.1, 10},
        {"rotateBy", 0.2, -20},
        {"rotateBy", 0.1, 10},
    }):at(self)


    self:line({
        {"delay", 0.9},
        {"fn", function()
            local particle = P.new("particle/zhuangyu.plist"):to(self):p(52, 50)
            particle:setAutoRemoveOnFinish(true)
        end},
    })
end


--------------------------
-- 触控
-------------------------- 

function M:onTouchBegan(x, y, touches)
    if self._touchLock then return end
    self._numNode._canPlayEffect = true
    self._numNode:stopGuide()
    self:getScene()._menuBtn:barChange(false)

    return SIGN_TOUCH_BEGAN_SWALLOWS
end

function M:onTouchMoved(x, y, touches)
    return self._numNode:pickUpFish(x, y)
end

function M:onTouchEnded(x, y, touches)
    self._numNode:fishBack()
end









----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end


return M