--[[

Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-3-16

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]

----------------------
-- 数字8用的铲雪车
----------------------
local M     = classSpriteTouch("N8SnowPlow")
M.TAG       = "N8SnowPlow"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..






----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	-- [超类调用]
	M.super.ctor(self, params)

	self._numNode 	= params.numNode
end




----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
	-- [超类调用]
	M.super.onRender(self)
	-- 图片渲染
	self:loadDisplay()
end


-- 图片渲染
function M:loadDisplay()
	self:display("num/write/num8/plow1.png")

	local particle = P.new("particle/chanxuehua.plist"):to(self, -1):p(self:cw()/2, self:ch() - 10):scale(0.75):hide()
	self._particle = particle
end

function M:quit()
	self:remove()
end


function M:playAni()
	if self._aniAction then return end
	self._particle:show()
	self._aniAction = A.cycle({
		{"image", "num/write/num8/plow", 2, 0.1},
	}):at(self)
end


function M:stopAni()
	if self._aniAction then
		self._particle:hide()
		self:stopAction(self._aniAction)
		self._aniAction = nil
		self:loadDisplay()
	end
end

function M:onTouchBegan(x, y, touches)
	if self._touchLock then return end
	self._numNode._canPlayEffect = true
	self._numNode:stopGuide()
	self:playAni()
    self:getScene()._menuBtn:barChange(false)
	return SIGN_TOUCH_BEGAN_SWALLOWS 
end

function M:onTouchMoved(x, y, touches)
	return self._numNode:shovelSnow(x, y)
end

function M:onTouchEnded(x, y, touches)
	self._numNode:plowBack()
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	-- [超类调用]
	M.super.onDestructor(self)
end



----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)
	
end


return M