--[[
Copyright (c) 2012-2020 Baby-Bus.com
Author: cxy
Date: 2021-2-27

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]
----------------------
-- 类 -- 数字1
----------------------
local M    = class("Num1", require("app.numwrite.numpath.NumBase"))
M.TAG    = "Num1"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..
----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)
    -- 数字
    self._number 	= 1

    self._strokeSize = 1.1
end

----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
end

-- 行李箱落下拉开拉链写1
function M:loadWriteItem()
	self._renderSprite:line({
		{"fadeTo", 0.5, 0},
		{"fn", function()
			CUtil:removeAd()
			local box = require("app.numwrite.numitem.N1Box").new({
				type_ 	= 1,
				layer 	= self._layer,
				numNode = self
			}):to(self:getParent(), self:z()):p(self:px(), self:py() + 600)

			soundEffect:playEffectsfx14711004()
			box:line({
				{"moveBy", 0.6, cc.p(0, -600)},
				{"fn", function()
					NV.addAd()
					CAction:feedback2(box)
					-- self._layer._numBone:amazeAct() 
				end},
			})
			self._box1 = box
		end},
	})
end

-- 拉拉链完成
function M:drawZipperFinish()
	self._zipperCount = self._zipperCount and (self._zipperCount + 1) or 1
	if self._zipperCount == 1 then
		soundEffect:playEffectsfx14711015()
		local box = require("app.numwrite.numitem.N1Box").new({
			type_ 	= 2,
			layer 	= self._layer,
			numNode = self
		}):to(self:getParent(), self:z()):p(self:px(), self:py()):scale(0)
		box:line({
			{"scaleTo", 0.3, 1.0},
		})

		self._box1:line({
			{"moveBy", 0.5, cc.p(0, -400)},
			{"remove"},
		})

		self._box2 = box
		self._layer._numBone:flyHatAct()
	else
		soundEffect:playEffectsfx14711016()
		self._layer._numBone:writeFinish()
	end
end

-- 向左移动 #移动的动作
function M:moveLeft(action)
	self._box2:runAction(action:clone())
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)

end

return M