--[[

Copyright (c) 2012-2020 Baby-Bus.com

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

]]

--[[!--

场景类，定义场景相关操作方法及逻辑实现。

-   定义场景功能方法。

]]

----------------------
-- 类 -- 形状匹配（喂食）场景
----------------------
local M = classScene("Shapefeed")


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..

-- [操作变量]
-- ..








----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义视图实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
	M.super.ctor(self, params)
	-- [超类调用]
	self:assertParameters(params)
end




----------------------
-- 视图渲染
----------------------
--[[--

视图渲染，处理视图结点加载、事件绑定等相关操作

]]
function M:onRender()
	G_addEnter("shapefeed")
	print("Hello Guy!") 
	print("Hello Number!") 
end




-- 点击返回按键的处理函数
function M:onKeypadBackHandler()
	local buttonLayer = self:getButtonLayer()
    -- 逻辑与当前场景的左上角点击返回一致
    if buttonLayer and buttonLayer.btnBackEvent then
    	buttonLayer:btnBackEvent()
    end
end




----------------------
-- 统计时长
----------------------
function M:beginPage()
	local fnName = "record"..string.sub(M.name, 1, -6).."Begin"
	if umengOP[fnName] then
		umengOP[fnName]()
	else
		print("统计时长开始-没有这个方法名", fnName)
	end
end

function M:endPage()
	local fnName = "record"..string.sub(M.name, 1, -6).."End"
	if umengOP[fnName] then
		umengOP[fnName]()
	else
		print("统计时长结束-没有这个方法名", fnName)
	end
end



-- 拖动场景忽略广告
function M:isIgnoreAdForDrag()
	return false
end
----------------------
-- 模板方法
----------------------
--[[--

获得层名称集合, 用于动态定义该场景需要加载的层

### Returns: 
-   string...       	层名称1, 层名称2, ...

]]
function M:getLayerNames()
	return "main","button"
end

--[[--

获得获得信息集合, 用于动态定义该场景需要加载的资源(纹理, 帧等)

### Returns: 
-   string|table...    	帧名称1|{资源名称,类型,自动清理,图片后缀(包含.)}, ...

]]
function M:getResourceNames()
	return 
end




-- 是否是开场动画
function M:isWelcomeScene()
	return false
end

--选择页面
function M:isSelectScene()
	return false
end
 
--loading界面
function M:isLoadingScene()
	return false
end

----------------------
-- 验证
----------------------
-- 验证参数
function M:assertParameters(params)

end




----------------------
-- 结点析构
----------------------
--[[--

视图析构，处理视图结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
	M.super.onDestructor(self)
end


return M