

local M = {}
---------------形状拼图对象配置表---------------
-- shapeTagTab用于区分是什么形状,如下:
--1 三角形
--2 正方形
--3 长方形
--4 圆形
--5 星形
--6 爱心形

-- 拼图Y轴偏移值
local devY1 = -15
local devY2 = 0
local devY3 = -20
local devY4 = -10
local devY5 = -5
local devY6 = -40

M.objectInfo = {
    -- 对象1:冰淇淋
    -- 顺序从下到上：{三角形,左圆形,右圆形,爱心形}
    {
        -- 形状图片文件路径字符串拼接
        shapeIdTab = {2, 3, 4, 1},  
        -- 用于区分是什么形状
        shapeTagTab = {1, 4, 4, 6},  
        -- 镜头缩放倍数
        cameraScaleTab = {0.7, 0.95, 1.3, 2},
        -- 形状的坐标表
        shapePosTab = {
            ccp(490.2+X_OFFSET, 132.4+devY1), ccp(428.1+X_OFFSET, 329.7+devY1), ccp(576.5+X_OFFSET, 305.1+devY1), ccp(334.2+X_OFFSET, 413.2+devY1)
        },
        -- 实物对象的坐标
        objPos = ccp(480.6+X_OFFSET, 220.8)
    },

    -- 对象2:圣诞树(这个改坐标要在obj中也改偏移值)
    -- 顺序从下到上：{长方形,下三角形,上三角形,五角星}
    {
        shapeIdTab = {3, 1, 1, 2},
        shapeTagTab = {3, 1, 1, 5},
        cameraScaleTab = {1.5, 1, 1, 1.5}, 
        shapePosTab = {
            ccp(480.0+X_OFFSET, 63+devY2), ccp(480.0+X_OFFSET, 184.2+devY2), ccp(480.0+X_OFFSET, 294+devY2), ccp(480.0+X_OFFSET, 390.5+devY2)
        },
        objPos = ccp(480.0+X_OFFSET, 218.2)
    },

    -- 对象3:小汽车
    -- 顺序从主体到末端：{左正方形,中正方形,右正方形,左三角形,中三角形,右三角形,左圆形,右圆形}
    {
        shapeIdTab = {4, 4, 4, 1, 2, 1, 3, 3},
        shapeTagTab = {2, 2, 2, 1, 1, 1, 4, 4},
        cameraScaleTab = {1.2, 1.2, 1.2, 1.2, 1.2, 1.2, 1.2, 1.2},
        shapePosTab = {
            ccp(338.7+X_OFFSET, 198.5+devY3), ccp(484+X_OFFSET, 198.5+devY3), ccp(629.7+X_OFFSET, 198.5+devY3), ccp(412.0+X_OFFSET, 321.5+devY3), 
            ccp(486+X_OFFSET, 325.5+devY3), ccp(567.8+X_OFFSET, 321.5+devY3), ccp(342.6+X_OFFSET, 144.6+devY3), ccp(617.0+X_OFFSET, 144.6+devY3)
        },
        objPos = ccp(480.0+X_OFFSET, 215.3)
    },

    -- 对象4:乌龟
    -- 顺序从主体到末端：{壳部,头部,左眼,右眼,左上三角形,左下三角形,右下三角形,右上三角形,尾巴}
    {
        shapeIdTab = {4, 5, 6, 6, 1, 2, 2, 1, 3},
        shapeTagTab = {4, 4, 4, 4, 1, 1, 1, 1, 1},
        cameraScaleTab = {0.8, 1.2, 2, 2, 1.5, 1.5, 1.5, 1.5, 2},
        shapePosTab = {
            ccp(480.0+X_OFFSET ,176.2+devY4), ccp(484.0+X_OFFSET, 353.0+devY4), ccp(451.9+X_OFFSET, 381.9+devY4), ccp(516.6+X_OFFSET, 381.9+devY4),
            ccp(350.0+X_OFFSET, 289.0+devY4), ccp(350.0+X_OFFSET, 62.2+devY4), ccp(610.0+X_OFFSET, 62.2+devY4), ccp(610.0+X_OFFSET, 289.0+devY4),
            ccp(480.0+X_OFFSET, 41.0+devY4)
        },
        objPos = ccp(480.0+X_OFFSET, 225.3)
    },

    -- 对象5:城堡
    -- 顺序从下到上，从左到右：{底部左长方形,底部左正方形,底部中大正方形,底部右正方形,底部右长方形,二层左长方形,
    --                     三层左三角形,二层扁长方形,三层正方形,四层三角形,二层右长方形,三层右三角形}
    {
        shapeIdTab = {4, 6, 5, 6, 4, 3, 1, 2, 6, 1, 3, 1},
        shapeTagTab = {3, 2, 2, 2, 3, 3, 1, 3, 2, 1, 3, 1},
        cameraScaleTab = {1.5, 1.5, 1, 1.5, 1.5, 1.5, 1.5, 1, 1.5, 1.5, 1.5, 1.5},
        shapePosTab = {
            ccp(253.0+X_OFFSET, 85.0+devY5), ccp(356.6+X_OFFSET, 94.0+devY5), ccp(479.5+X_OFFSET, 117.8+devY5), ccp(602.6+X_OFFSET, 94.0+devY5),
            ccp(706.4+X_OFFSET, 85.0+devY5), ccp(253.0+X_OFFSET, 160.6+devY5), ccp(253.0+X_OFFSET, 248.8+devY5), ccp(480.0+X_OFFSET, 207.0+devY5),
            ccp(480.0+X_OFFSET, 271.8+devY5), ccp(480.0+X_OFFSET, 370.0+devY5), ccp(707.0+X_OFFSET, 160.6+devY5), ccp(707.0+X_OFFSET, 248.8+devY5)
        },
        objPos = ccp(480.0+X_OFFSET, 229.4)
    },

    -- 对象6:生日蛋糕
    -- 顺序从主体到末端：{下宽长方形,中宽长方形,上宽长方形,左爱心,中爱心,右爱心,左窄长方形,中窄长方形,右窄长方形,
    --                右三角形,中三角形,左三角形,}
    {
        shapeIdTab = {6, 5, 4, 1, 2, 1, 7, 7, 7, 3, 3, 3},
        shapeTagTab = {3, 3, 3, 6, 6, 6, 3, 3, 3, 1, 1, 1},
        cameraScaleTab = {0.7, 0.8, 1, 2, 2, 2, 2.8, 2.8, 2.8, 3, 3, 3},
        shapePosTab = {
            ccp(481.0+X_OFFSET, 118.0+devY6), ccp(479.0+X_OFFSET, 226.5+devY6), ccp(475.0+X_OFFSET, 307.8+devY6),ccp(398.0+X_OFFSET, 213.0+devY6),
            ccp(478.0+X_OFFSET, 213.0+devY6), ccp(558.0+X_OFFSET, 213.0+devY6), ccp(413.0+X_OFFSET, 370.0+devY6), ccp(480.0+X_OFFSET, 370.0+devY6),
            ccp(541.0+X_OFFSET, 370.0+devY6), ccp(413.0+X_OFFSET, 421.0+devY6), ccp(480.0+X_OFFSET, 421.0+devY6), ccp(541.0+X_OFFSET, 421.0+devY6)
        },
        objPos = ccp(480.0+X_OFFSET, 160.6)
    }
}

return M