--[[Copyright (c) 2012-2021 Baby-Bus.com
Author: cxy
Date: 2021-1-13

]]
--[[!--

游戏角色类，定义游戏角色公用操作方法及逻辑实现。

-   定义游戏角色相关信息。

]]
----------------------
-- 类
----------------------
local M    = classSpriteTouch("Outline")
M.TAG    = "Outline"


----------------------
-- 公共参数
----------------------
-- [常量]
-- ..
----------------------
-- 构造方法
----------------------
--[[--

构造方法，定义结点实例初始化逻辑

### Parameters:
-   table **params**    参数集合

### Return: 
-   object              对象实例

]]
function M:ctor(params)
    -- [超类调用]
    M.super.ctor(self, params)

    -- 摄像机节点
    self._camera = params.camera
    -- 形状标识
	self._shapeTag = params.shapeTag 
    -- 渲染虚线框图片的文件路径
    self._imgPath = params.imgPath
    -- 初始坐标位置   
	self._initPos = params.initPos
end

----------------------
-- 结点渲染 
----------------------
--[[--

实体渲染，处理实体结点加载、事件绑定等相关操作

]]
function M:onRender()
    -- [超类调用]
    M.super.onRender(self)
    -- 图片渲染
    self:loadDisplay()
end

-- 图片渲染
function M:loadDisplay()
    self:display(self._imgPath)
end

-- 虚线轮廓进场效果
function M:enterEffect()
    -- 播放音效[sfx14707001]虚线框冒出/虚线框冒出的时候播放
    soundEffect:playEffectsfx14707001()
    self:line({
        { "easing", "backOut", { "scaleTo", 0.5, 1 } },
    })
end

-- 轮廓消失效果
function M:quitEffect()
    self:line({
		{ "fadeTo", 0.5, 0 },
        { "remove" }
    })
end

----------------------
-- 结点析构
----------------------
--[[--

实体析构，处理实体结点卸载、事件解除绑定等相关操作

]]
function M:onDestructor()
    -- [超类调用]
    M.super.onDestructor(self)
end


----------------------
-- 点击
----------------------
function M:onTouchBegan(x, y, touches)
    return true
end

function M:onTouchMoved(x, y, touches)

end

function M:onTouchEnded(x, y, touches)

end


----------------------
-- 验证
----------------------
-- 验证合法性[构造函数参数]
function M:assertParameters(params)

end


return M